/*
 * TWE Control
 * 2013-11-25
 * TOKYO COSMOS CO.,LTD.
 * 
 */

package jp.ksksue.tutorial.TWE_Control;





import jp.ksksue.driver.serial.FTDriver;
import android.app.Activity;
import android.app.PendingIntent;
import android.content.Context;
import android.content.Intent;
import android.hardware.usb.UsbManager;
import android.os.Bundle;
import android.os.Handler;
import android.view.Menu;
import android.view.View;
import android.widget.Button;
import android.widget.ScrollView;
import android.widget.SeekBar;
import android.widget.TextView;
import android.widget.Toast;
import android.widget.ImageView;
import android.widget.SeekBar.OnSeekBarChangeListener;
import android.util.Log;
import java.util.Locale;


public class TWE_Control extends Activity {

	final int mOutputType = 0;
	final boolean SHOW_LOGCAT = false;
	
    // [FTDriver] Object
    FTDriver mSerial;
    
    private TextView mTvSerial1,mTvSerial2,mTvSerial3,mTvSerial4,mTvSerial5,mTvSerial6,mTvSerial7;
    private String mText1,mText2,mText3,mText4,mText5,mText6,mText7;
    private boolean mStop = false;
    private boolean mRunningMainLoop = false;

    String TAG = "FTSampleTerminal";
    Handler mHandler = new Handler();
    
    SeekBar seekBar1,seekBar2,seekBar3,seekBar4;
    TextView tv1,tv2,tv3,tv4;
        
	
    
    // [FTDriver] Permission String
    private static final String ACTION_USB_PERMISSION =
            "jp.ksksue.tutorial.USB_PERMISSION";
    
    Button btnBegin,LED1_ON,LED1_OFF,LED2_ON,LED2_OFF,LED3_ON,LED3_OFF,LED4_ON,LED4_OFF,btnEnd,LEDALL_ON,LEDALL_OFF;
    TextView tvMonitor;
    
    
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        
        
        ImageView imageview = new ImageView(this);
        imageview.setImageResource(R.drawable.tocos01);
        setContentView(imageview);
        
        setContentView(R.layout.activity_twe_control);
        
        mTvSerial1 = (TextView) findViewById(R.id.tvSerial1);
        mTvSerial2 = (TextView) findViewById(R.id.tvSerial2);
        mTvSerial3 = (TextView) findViewById(R.id.tvSerial3);
        mTvSerial4 = (TextView) findViewById(R.id.tvSerial4);
        mTvSerial5 = (TextView) findViewById(R.id.tvSerial5);
        mTvSerial6 = (TextView) findViewById(R.id.tvSerial6);
        mTvSerial7 = (TextView) findViewById(R.id.tvSerial7);

        seekBar1 = (SeekBar)findViewById(R.id.seekBar1);
        seekBar2 = (SeekBar)findViewById(R.id.seekBar2);
        seekBar3 = (SeekBar)findViewById(R.id.seekBar3);
        seekBar4 = (SeekBar)findViewById(R.id.seekBar4);
        tv1 = (TextView)findViewById(R.id.textView3); 
        tv2 = (TextView)findViewById(R.id.textView4);
        tv3 = (TextView)findViewById(R.id.textView5);
        tv4 = (TextView)findViewById(R.id.textView6);
        btnBegin = (Button) findViewById(R.id.btnBegin);
        LED1_ON = (Button) findViewById(R.id.LED1_ON);
        LED1_OFF = (Button) findViewById(R.id.LED1_OFF);
        LED2_ON = (Button) findViewById(R.id.LED2_ON);
        LED2_OFF = (Button) findViewById(R.id.LED2_OFF);
        LED3_ON = (Button) findViewById(R.id.LED3_ON);
        LED3_OFF = (Button) findViewById(R.id.LED3_OFF);
        LED4_ON = (Button) findViewById(R.id.LED4_ON);
        LED4_OFF = (Button) findViewById(R.id.LED4_OFF);
        btnEnd = (Button) findViewById(R.id.btnEnd);
        LEDALL_ON = (Button) findViewById(R.id.LEDALL_ON);
        LEDALL_OFF = (Button) findViewById(R.id.LEDALL_OFF);
        
        LED1_ON.setEnabled(false);
        LED1_OFF.setEnabled(false);
        LED2_ON.setEnabled(false);
        LED2_OFF.setEnabled(false);
        LED3_ON.setEnabled(false);
        LED3_OFF.setEnabled(false);
        LED4_ON.setEnabled(false);
        LED4_OFF.setEnabled(false);
        LEDALL_ON.setEnabled(false);
        LEDALL_OFF.setEnabled(false);
        btnEnd.setEnabled(false);
        
        seekBar1.setEnabled(false);
        seekBar2.setEnabled(false);
        seekBar3.setEnabled(false);
        seekBar4.setEnabled(false);
        
        tv1.setText("PWM1:"+seekBar1.getProgress());
        tv2.setText("PWM2:"+seekBar2.getProgress());
        tv3.setText("PWM3:"+seekBar3.getProgress());
        tv4.setText("PWM4:"+seekBar4.getProgress());
        
		seekBar1.setOnSeekBarChangeListener(                 
				new OnSeekBarChangeListener() {                     
					public void onProgressChanged(SeekBar seekBar,                             
							int progress, boolean fromUser) {                         
						
						// c}~hbOƂɌĂ΂                         
						tv1.setText("PWM1:"+progress);
						if (progress == 0){
					        String wbuf = ":78800100000000FFFFFFFFFFFF0D\r\n";
					        mSerial.write(wbuf.getBytes());				        						
						}						
						if (progress == 1){
							String wbuf = ":78800100000066FFFFFFFFFFFFA7\r\n";
					        mSerial.write(wbuf.getBytes());				        							
						}						
						if (progress == 2){
							String wbuf = ":788001000000CCFFFFFFFFFFFF41\r\n";
					        mSerial.write(wbuf.getBytes());				        							
						}					
						if (progress == 3){
							String wbuf = ":78800100000133FFFFFFFFFFFFD9\r\n";
					        mSerial.write(wbuf.getBytes());				        							
						}						
						if (progress == 4){
							String wbuf = ":7880010000019AFFFFFFFFFFFF72\r\n";
					        mSerial.write(wbuf.getBytes());				        							
						}					
						if (progress == 5){
							String wbuf = ":78800100000200FFFFFFFFFFFF0B\r\n";
					        mSerial.write(wbuf.getBytes());				        							
						}
						if (progress == 6){
							String wbuf = ":78800100000266FFFFFFFFFFFFA5\r\n";
					        mSerial.write(wbuf.getBytes());				        							
						}		
						if (progress == 7){
							String wbuf = ":788001000002CDFFFFFFFFFFFF3E\r\n";
					        mSerial.write(wbuf.getBytes());				        							
						}
						if (progress == 8){
							String wbuf = ":78800100000333FFFFFFFFFFFFD7\r\n";
					        mSerial.write(wbuf.getBytes());				        							
						}
						if (progress == 9){
							String wbuf = ":7880010000039AFFFFFFFFFFFF70\r\n";
					        mSerial.write(wbuf.getBytes());				        							
						}
						if (progress == 10){
							String wbuf = ":78800100000400FFFFFFFFFFFF09\r\n";
					        mSerial.write(wbuf.getBytes());					
						}
					}										
					public void onStartTrackingTouch(SeekBar seekBar) {                         
						
						}                       
				    public void onStopTrackingTouch(SeekBar seekBar) {                                           
				    }                 
				    }         
			); 
		
		seekBar2.setOnSeekBarChangeListener(                 
				new OnSeekBarChangeListener() {                     
					public void onProgressChanged(SeekBar seekBar,                             
							int progress, boolean fromUser) {                                           
						tv2.setText("PWM2:"+progress);
						if (progress == 0){
					        String wbuf = ":7880010000FFFF0000FFFFFFFF0D\r\n";
					        mSerial.write(wbuf.getBytes());					        							
						}						
						if (progress == 1){
							String wbuf = ":7880010000FFFF0066FFFFFFFFA7\r\n";
					        mSerial.write(wbuf.getBytes());				        							
						}						
						if (progress == 2){
							String wbuf = ":7880010000FFFF00CCFFFFFFFF41\r\n";
					        mSerial.write(wbuf.getBytes());				        							
						}					
						if (progress == 3){
							String wbuf = ":7880010000FFFF0133FFFFFFFFD9\r\n";
					        mSerial.write(wbuf.getBytes());			        							
						}					
						if (progress == 4){
							String wbuf = ":7880010000FFFF019AFFFFFFFF72\r\n";
					        mSerial.write(wbuf.getBytes());			        							
						}					
						if (progress == 5){
							String wbuf = ":7880010000FFFF0200FFFFFFFF0B\r\n";
					        mSerial.write(wbuf.getBytes());			        							
						}
						if (progress == 6){
							String wbuf = ":7880010000FFFF0266FFFFFFFFA5\r\n";
					        mSerial.write(wbuf.getBytes());			        							
						}
						if (progress == 7){
							String wbuf = ":7880010000FFFF02CDFFFFFFFF3E\r\n";
					        mSerial.write(wbuf.getBytes());			        							
						}
						if (progress == 8){
							String wbuf = ":7880010000FFFF0333FFFFFFFFD7\r\n";
					        mSerial.write(wbuf.getBytes());			        							
						}
						if (progress == 9){
							String wbuf = ":7880010000FFFF039AFFFFFFFF70\r\n";
					        mSerial.write(wbuf.getBytes());			        							
						}
						if (progress == 10){
							String wbuf = ":7880010000FFFF0400FFFFFFFF09\r\n";
					        mSerial.write(wbuf.getBytes());			        							
						}
						}										
						public void onStartTrackingTouch(SeekBar seekBar) {                         
							
							}                       
					    public void onStopTrackingTouch(SeekBar seekBar) {                                           
					    }                 
					    }         
				); 
		
		seekBar3.setOnSeekBarChangeListener(                 
				new OnSeekBarChangeListener() {                     
					public void onProgressChanged(SeekBar seekBar,                             
							int progress, boolean fromUser) {                                           
						tv3.setText("PWM3:"+progress);
						if (progress == 0){
					        String wbuf = ":7880010000FFFFFFFF0000FFFF0D\r\n";
					        mSerial.write(wbuf.getBytes());					        							
						}						
						if (progress == 1){
							String wbuf = ":7880010000FFFFFFFF0066FFFFA7\r\n";
					        mSerial.write(wbuf.getBytes());				        							
						}						
						if (progress == 2){
							String wbuf = ":7880010000FFFFFFFF00CCFFFF41\r\n";
					        mSerial.write(wbuf.getBytes());			        							
						}						
						if (progress == 3){
							String wbuf = ":7880010000FFFFFFFF0133FFFFD9\r\n";
					        mSerial.write(wbuf.getBytes());				        							
						}						
						if (progress == 4){
							String wbuf = ":7880010000FFFFFFFF019AFFFF72\r\n";
					        mSerial.write(wbuf.getBytes());				        							
						}						
						if (progress == 5){
							String wbuf = ":7880010000FFFFFFFF0200FFFF0B\r\n";
					        mSerial.write(wbuf.getBytes());				        							
						}
						if (progress == 6){
							String wbuf = ":7880010000FFFFFFFF0266FFFFA5\r\n";
					        mSerial.write(wbuf.getBytes());				        							
						}
						if (progress == 7){
							String wbuf = ":7880010000FFFFFFFF02CDFFFF3E\r\n";
					        mSerial.write(wbuf.getBytes());				        							
						}
						if (progress == 8){
							String wbuf = ":7880010000FFFFFFFF0333FFFFD7\r\n";
					        mSerial.write(wbuf.getBytes());				        							
						}
						if (progress == 9){
							String wbuf = ":7880010000FFFFFFFF039AFFFF70\r\n";
					        mSerial.write(wbuf.getBytes());				        							
						}
						if (progress == 10){
							String wbuf = ":7880010000FFFFFFFF0400FFFF09\r\n";
					        mSerial.write(wbuf.getBytes());				        							
						}
						
						}										
						public void onStartTrackingTouch(SeekBar seekBar) {                         
							
							}                       
					    public void onStopTrackingTouch(SeekBar seekBar) {                                           
					    }                 
					    }         
				);
		
		seekBar4.setOnSeekBarChangeListener(                 
				new OnSeekBarChangeListener() {                     
					public void onProgressChanged(SeekBar seekBar,                             
							int progress, boolean fromUser) {                                           
						tv4.setText("PWM4:"+progress);
						if (progress == 0){
					        String wbuf = ":7880010000FFFFFFFFFFFF00000D\r\n";
					        mSerial.write(wbuf.getBytes());					        							
						}					
						if (progress == 1){
							String wbuf = ":7880010000FFFFFFFFFFFF0066A7\r\n";
					        mSerial.write(wbuf.getBytes());	        							
						}			
						if (progress == 2){
							String wbuf = ":7880010000FFFFFFFFFFFF00CC41\r\n";
					        mSerial.write(wbuf.getBytes());	        							
						}			
						if (progress == 3){
							String wbuf = ":7880010000FFFFFFFFFFFF0133D9\r\n";
					        mSerial.write(wbuf.getBytes());		        							
						}					
						if (progress == 4){
							String wbuf = ":7880010000FFFFFFFFFFFF019A72\r\n";
					        mSerial.write(wbuf.getBytes());			        							
						}					
						if (progress == 5){
							String wbuf = ":7880010000FFFFFFFFFFFF02000B\r\n";
					        mSerial.write(wbuf.getBytes());			        							
						}
						if (progress == 6){
							String wbuf = ":7880010000FFFFFFFFFFFF0266A5\r\n";
					        mSerial.write(wbuf.getBytes());		
						}
						if (progress == 7){
							String wbuf = ":7880010000FFFFFFFFFFFF02CD3E\r\n";
					        mSerial.write(wbuf.getBytes());		
						}
						if (progress == 8){
							String wbuf = ":7880010000FFFFFFFFFFFF0333D7\r\n";
					        mSerial.write(wbuf.getBytes());		
						}
						if (progress == 9){
							String wbuf = ":7880010000FFFFFFFFFFFF039A70\r\n";
					        mSerial.write(wbuf.getBytes());		
						}
						if (progress == 10){
							String wbuf = ":7880010000FFFFFFFFFFFF040009\r\n";
					        mSerial.write(wbuf.getBytes());		
						}
						}										
						public void onStartTrackingTouch(SeekBar seekBar) {                         
							
							}                       
					    public void onStopTrackingTouch(SeekBar seekBar) {                                           
					    }                 
					    }         
				);
					
        
        // [FTDriver] Create Instance
        mSerial = new FTDriver((UsbManager)getSystemService(Context.USB_SERVICE));

        // [FTDriver] setPermissionIntent() before begin()
        PendingIntent permissionIntent = PendingIntent.getBroadcast(this, 0, new Intent(
                ACTION_USB_PERMISSION), 0);
        mSerial.setPermissionIntent(permissionIntent);
        

    }

/*    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        getMenuInflater().inflate(R.menu.activity_ftdriver_tutorial1, menu);
        return true;
    }
  */  
    @Override
    public void onDestroy() {
        super.onDestroy();

        // [FTDriver] Close USB Serial
        mSerial.end();
    }
    
    public void onBeginClick(View view) {
        // [FTDriver] Open USB Serial
        if(mSerial.begin(FTDriver.BAUD115200)) {
        	
        	mainloop();
        	mStop = false;
            btnBegin.setEnabled(false);
            LED1_ON.setEnabled(true);
            LED1_OFF.setEnabled(true);
            LED2_ON.setEnabled(true);
            LED2_OFF.setEnabled(true);
            LED3_ON.setEnabled(true);
            LED3_OFF.setEnabled(true);
            LED4_ON.setEnabled(true);
            LED4_OFF.setEnabled(true);
            btnEnd.setEnabled(true);
            LEDALL_ON.setEnabled(true);
            LEDALL_OFF.setEnabled(true);
            
            String wbuf = ":788001000F0000000000000000F8\r\n";
            mSerial.write(wbuf.getBytes());
            
            seekBar1.setEnabled(true);
            seekBar2.setEnabled(true);
            seekBar3.setEnabled(true);
            seekBar4.setEnabled(true);
            
            Toast.makeText(this, "ڑ܂", Toast.LENGTH_SHORT).show();
        } else {
            Toast.makeText(this, "ڑł܂", Toast.LENGTH_SHORT).show();
        }
    }
    
    
    private void mainloop() {
    	
    	mRunningMainLoop = true;
		new Thread(mLoop).start();
    }
    
	private Runnable mLoop = new Runnable() {
		@Override
		public void run() {
        int i,len;
        

        // [FTDriver] Create Read Buffer
        byte[] rbuf = new byte[4096]; // 1byte <--slow-- [Transfer Speed] --fast--> 4096 byte
        for(;;){
        // [FTDriver] Read from USB Serial
        len = mSerial.read(rbuf);
        String str1 = new String(rbuf);
      
        String new_str1 = str1.substring(9,11);
        String new_str2 = str1.substring(27,31);
        String new_str3 = str1.substring(33,35);
        String new_str4 = str1.substring(37,39);
        String new_str5 = str1.substring(39,41);
        String new_str6 = str1.substring(41,43);
        String new_str7 = str1.substring(43,45);
        
        
        final ScrollView scrollview = ((ScrollView) findViewById(R.id.scroller));     
        scrollview.post(new Runnable() {     
        	@Override    public void run() {         
        		scrollview.fullScroll(ScrollView.FOCUS_DOWN);
        		} 
        	}); 
      
		if(len > 0) {
			if(SHOW_LOGCAT) { Log.i(TAG,"Read  Length : "+len); }
			mText1 = (String) mTvSerial1.getText();
			mText2 = (String) mTvSerial2.getText();
			mText3 = (String) mTvSerial3.getText();
			mText4 = (String) mTvSerial4.getText();
			mText5 = (String) mTvSerial5.getText();
			mText6 = (String) mTvSerial6.getText();
			mText7 = (String) mTvSerial7.getText();
			
			try{ //G[oȏLq
		          String x,y;
					int a,b;
 
					x = new_str1.toLowerCase(Locale.ENGLISH);
			        y = new_str2.toLowerCase(Locale.ENGLISH);

					a = Integer.parseInt(x, 16);	
					b = Integer.parseInt(y, 16);
					
						  			
			
			for(i=0;i<len;++i) {
				if(SHOW_LOGCAT) { Log.i(TAG,"Read  Data["+i+"] : "+rbuf[i]); }
							
				
				 if (rbuf[i] == 0x0A) {
					
						mText1 = "" +String.valueOf(a) +"\n";					 			 
						mText2 = "" +String.valueOf(b) +"\n";				 
						mText3 = "" +new_str3 +"\n";
						mText4 = "" +new_str4 +"\n";
						mText5 = "" +new_str5 +"\n";
						mText6 = "" +new_str6 +"\n";
						mText7 = "" +new_str7 +"\n";
					 }			 		
				
			}
			
		}
		catch(NumberFormatException nfe)
		{
		  //G[ȍLq
		}
			
			mHandler.post(new Runnable() {
				public void run() {
					mTvSerial1.setText(mText1);
					mTvSerial2.setText(mText2);
					mTvSerial3.setText(mText3);
					mTvSerial4.setText(mText4);
					mTvSerial5.setText(mText5);
					mTvSerial6.setText(mText6);
					mTvSerial7.setText(mText7);
				}
			});
		}
		
		try {
			Thread.sleep(50);
		} catch (InterruptedException e) {
			e.printStackTrace();
		}
		
		if(mStop) {
			mRunningMainLoop = false;
			return;
		}
	}
}
};
    
    
    
    public void onLED1_ONClick(View view) {
    	
        String wbuf = ":7880010101FFFFFFFFFFFFFFFF0D\r\n";

        // [FTDriver] Wirte to USB Serial
        mSerial.write(wbuf.getBytes());
        
        
        
    }
    public void onLED1_OFFClick(View view) {
    	
        String wbuf = ":7880010001FFFFFFFFFFFFFFFF0E\r\n";
        mSerial.write(wbuf.getBytes());
        
   
        
    }    
    public void onLED2_ONClick(View view) {
    	
        String wbuf = ":7880010202FFFFFFFFFFFFFFFF0B\r\n";
        mSerial.write(wbuf.getBytes());
        
        
    }
    public void onLED2_OFFClick(View view) {
    	
        String wbuf = ":7880010002FFFFFFFFFFFFFFFF0D\r\n";
        mSerial.write(wbuf.getBytes());
              
    } 
    
   public void onLED3_ONClick(View view) {
    	
        String wbuf = ":7880010404FFFFFFFFFFFFFFFF07\r\n";
        mSerial.write(wbuf.getBytes());
               
    }
    public void onLED3_OFFClick(View view) {
    	
        String wbuf = ":7880010004FFFFFFFFFFFFFFFF0B\r\n";
        mSerial.write(wbuf.getBytes());
               
    }    
    
   public void onLED4_ONClick(View view) {
    	
        String wbuf = ":7880010808FFFFFFFFFFFFFFFFFF\r\n";
        mSerial.write(wbuf.getBytes());
                
    }
    public void onLED4_OFFClick(View view) {
    	
        String wbuf = ":7880010008FFFFFFFFFFFFFFFF07\r\n";
        mSerial.write(wbuf.getBytes());
       
       
    }
    
    public void LEDALL_ONClick(View view) {
    	
        String wbuf = ":7880010F0F0400040004000400D9\r\n";
        mSerial.write(wbuf.getBytes());
       
       
    }
    
    public void LEDALL_OFFClick(View view) {
    	
        String wbuf = ":788001000F0000000000000000F8\r\n";
        mSerial.write(wbuf.getBytes());
          
    }
    
    
        
    public void onEndClick(View view) {
        // [FTDriver] Close USB Serial
    	
        String wbuf = ":788001000F0000000000000000F8\r\n";
        mSerial.write(wbuf.getBytes());
    	  	
        mStop = true;
        btnBegin.setEnabled(true);
        LED1_ON.setEnabled(false);
        LED1_OFF.setEnabled(false);
        LED2_ON.setEnabled(false);
        LED2_OFF.setEnabled(false);
        LED3_ON.setEnabled(false);
        LED3_OFF.setEnabled(false);
        LED4_ON.setEnabled(false);
        LED4_OFF.setEnabled(false);
        btnEnd.setEnabled(false);
        LEDALL_ON.setEnabled(false);
        LEDALL_OFF.setEnabled(false);
        
        seekBar1.setProgress(0);
        seekBar2.setProgress(0);
        seekBar3.setProgress(0);
        seekBar4.setProgress(0);
                
        seekBar1.setEnabled(false);
        seekBar2.setEnabled(false);
        seekBar3.setEnabled(false);
        seekBar4.setEnabled(false);
        
        mSerial.end();

        
        Toast.makeText(this, "ؒf܂", Toast.LENGTH_SHORT).show();
    }
}
